// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RBCalendar.pas' rev: 4.00

#ifndef RBCalendarHPP
#define RBCalendarHPP

#pragma delphiheader begin
#pragma option push -w-
#include <Menus.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rbcalendar
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 4)
struct TRBCMonthDay
{
	char Text[2];
	int TextLen;
	Word Flags;
	TDate Day;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TRBMonthData
{
	int Month;
	int Year;
	TDate FirstDate;
	TDate LastDate;
	int FirstWeekDay;
	int LastWeekDay;
	int LastDay;
	int PrevMonthLastDay;
	int PrevMonth;
	int PrevMonthYear;
	int NextMonth;
	int NextMonthYear;
	TRBCMonthDay Days[7][6];
	TDate WeekStart[6];
} ;
#pragma pack(pop)

typedef void __fastcall (__closure *TRBCMarkEvent)(System::TObject* Sender, TDate Day, bool &Mark);

#pragma option push -b-
enum TRBCSelectionKind { skNone, skSingleDay, skWeek, skProgressive, skFree };
#pragma option pop

#pragma option push -b-
enum TRBCFirstWeekDay { fwdSunday, fwdMonday, fwdTuesday, fwdWednesday, fwdThursday, fwdFriday, fwdSaturday 
	};
#pragma option pop

typedef void __fastcall (__closure *TRBCCellDrawEvent)(System::TObject* Sender, TDate Day, bool Selected
	, bool Marked, bool InMonth, Graphics::TCanvas* Canvas, const Windows::TRect &Rect);

typedef void __fastcall (__closure *TRBCCaptionDrawEvent)(System::TObject* Sender, int Month, int Year
	, Graphics::TCanvas* Canvas, const Windows::TRect &Rect);

typedef void __fastcall (__closure *TRBCTitleDrawEvent)(System::TObject* Sender, int Month, int Year
	, int Day, Graphics::TCanvas* Canvas, const Windows::TRect &Rect);

typedef void __fastcall (__closure *TRBCCanSelectEvent)(System::TObject* Sender, TDate Day, bool &CanSelect
	);

class DELPHICLASS TRBCSelection;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TRBCSelection : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	TDate Day;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TRBCSelection(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TRBCSelection(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TRBCalendar;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TRBCalendar : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	Classes::TList* FSelections;
	bool AddingSelection;
	bool SelectingWeeks;
	int FirstWeekDayOffset;
	Stdctrls::TCustomListBox* FNavigList;
	int NavigListMonthOffset;
	TRBMonthData MonthsData[10][10];
	int FMonthWidth;
	int FMonthHeight;
	int FMonthsInWidth;
	int FMonthsInHeight;
	TDate StartDate;
	TDate EndDate;
	bool SelectingDates;
	TDate SelectStartDay;
	TDate SelectEndDay;
	int ClickTimer;
	bool ClickingPrevMonth;
	bool ClickingNextMonth;
	Forms::TFormBorderStyle FBorderStyle;
	bool FShowLines;
	bool FFixedSize;
	int FDayWidth;
	int FDayHeight;
	int FYear;
	int FMonth;
	TDate FSelectionFromDate;
	TDate FSelectionToDate;
	bool FShowPrevMonth;
	bool FShowNextMonth;
	bool FPrevMonthButton;
	bool FNextMonthButton;
	Graphics::TColor FPrevMonthColor;
	Graphics::TColor FNextMonthColor;
	int FBorderWidth;
	int FCaptionHeight;
	int FTitlesHeight;
	Classes::TNotifyEvent FOnSelectionChange;
	TRBCMarkEvent FOnMark;
	int FPopupListDays;
	bool FEnableCaptionPopup;
	bool FShowToday;
	Graphics::TColor FTodayColor;
	Graphics::TColor FCaptionsColor;
	Graphics::TColor FTitlesColor;
	TRBCSelectionKind FSelectionKind;
	Controls::TCursor FCursor;
	bool FSideWeekSelect;
	TRBCFirstWeekDay FFirstWeekDay;
	Graphics::TColor FSelectionColor;
	Graphics::TColor FSelectionTextColor;
	bool FShowDividers;
	Graphics::TColor FDividersColor;
	bool FFlatLook;
	bool FCustomCaptionsDraw;
	bool FCustomCellsDraw;
	TRBCCellDrawEvent FOnCellDraw;
	TRBCCaptionDrawEvent FOnCaptionDraw;
	bool FCustomTitlesDraw;
	TRBCTitleDrawEvent FOnTitleDraw;
	Classes::TAlignment FDayAlignment;
	TRBCCanSelectEvent FOnCanSelect;
	bool FCanSelectAnother;
	bool FMultiSelect;
	int FMaxSelections;
	void __fastcall SetBorderStyle(Forms::TBorderStyle Value);
	void __fastcall SetMonthsInWidth(int Value);
	void __fastcall SetMonthsInHeight(int Value);
	void __fastcall SetDayWidth(int Value);
	void __fastcall SetDayHeight(int Value);
	void __fastcall SetShowLines(bool Value);
	void __fastcall SetNextMonthButton(bool Value);
	void __fastcall SetPrevMonthButton(bool Value);
	void __fastcall SetFixedSize(bool Value);
	void __fastcall SetYear(int Value);
	void __fastcall SetMonth(int Value);
	void __fastcall SetShowPrevMonth(bool Value);
	void __fastcall SetShowNextMonth(bool Value);
	void __fastcall SetPrevMonthColor(Graphics::TColor Value);
	void __fastcall SetNextMonthColor(Graphics::TColor Value);
	HIDESBASE void __fastcall SetBorderWidth(int Value);
	void __fastcall SetCaptionHeight(int Value);
	void __fastcall SetTitlesHeight(int Value);
	void __fastcall SetSelectionFromDate(TDate Value);
	void __fastcall SetSelectionToDate(TDate Value);
	int __fastcall GetDaysSelected(void);
	void __fastcall SetPopupListDays(const int Value);
	void __fastcall SetEnableCaptionPopup(const bool Value);
	void __fastcall SetShowToday(const bool Value);
	void __fastcall SetTodayColor(const Graphics::TColor Value);
	void __fastcall SetCaptionsColor(const Graphics::TColor Value);
	void __fastcall SetTitlesColor(const Graphics::TColor Value);
	void __fastcall SetSelectionKind(const TRBCSelectionKind Value);
	HIDESBASE void __fastcall SetCursor(const Controls::TCursor Value);
	void __fastcall SetSideWeekSelect(const bool Value);
	void __fastcall SetFirstWeekDay(const TRBCFirstWeekDay Value);
	Windows::TPoint __fastcall GetPointFromDate(int Day, int I, int J);
	bool __fastcall DoesSelectionExist(TDate Day);
	void __fastcall SetSelectionColor(const Graphics::TColor Value);
	void __fastcall SetSelectionTextColor(const Graphics::TColor Value);
	void __fastcall SetDividersColor(const Graphics::TColor Value);
	void __fastcall SetShowDividers(const bool Value);
	void __fastcall DrawLeftArrow(Graphics::TCanvas* Canvas, const Windows::TRect &Rect, Graphics::TColor 
		Color);
	void __fastcall DrawRightArrow(Graphics::TCanvas* Canvas, const Windows::TRect &Rect, Graphics::TColor 
		Color);
	void __fastcall DrawFlatFrame(Graphics::TCanvas* Canvas, const Windows::TRect &Rect);
	void __fastcall SetFlatLook(const bool Value);
	void __fastcall SetCustomCaptionsDraw(const bool Value);
	void __fastcall SetCustomCellsDraw(const bool Value);
	void __fastcall SetCustomTitlesDraw(const bool Value);
	void __fastcall SetDayAlignment(const Classes::TAlignment Value);
	void __fastcall SetCanSelectAnother(const bool Value);
	void __fastcall SetMultiSelect(const bool Value);
	void __fastcall SetMaxSelections(const int Value);
	void __fastcall SetOnMark(const TRBCMarkEvent Value);
	
protected:
	Classes::TNotifyEvent OldFontChanged;
	void __fastcall MyFontChanged(System::TObject* Sender);
	bool __fastcall IsLeapYear(int AYear);
	int __fastcall DaysInMonth(int AMonth, int AYear);
	void __fastcall CalcMonthData(int I, int J);
	void __fastcall CalcMonthsData(void);
	void __fastcall CalcDimensions(void);
	void __fastcall PaintPrevMonthButton(void);
	void __fastcall PaintNextMonthButton(void);
	void __fastcall PaintCaption(int I, int J);
	void __fastcall PaintTitles(int I, int J);
	void __fastcall PaintMonth(int I, int J);
	void __fastcall PaintDividers(int I, int J);
	void __fastcall PaintMonths(void);
	bool __fastcall InternalSelectDates(TDate FromDate, TDate ToDate);
	bool __fastcall InternalAddSelections(TDate FromDate, TDate ToDate);
	bool __fastcall InternalRemoveSelection(TDate FromDate, TDate ToDate);
	bool __fastcall InternalSetSelections(TDate FromDate, TDate ToDate);
	void __fastcall InternalAddSelection(TRBCSelection* Selection);
	bool __fastcall NeedToMoveToPrevMonth(void);
	bool __fastcall NeedToMoveToNextMonth(void);
	bool __fastcall IsDaySelected(TDate ADay);
	void __fastcall PaintDates(int I, int J);
	void __fastcall PaintPrevMonthDates(void);
	void __fastcall PaintNextMonthDates(void);
	virtual void __fastcall Paint(void);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int x, 
		int y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int x, int y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int x, int 
		y);
	MESSAGE void __fastcall WMTimer(Messages::TWMTimer &Message);
	void __fastcall HandleClickOnCalendar(int I, int J, int X, int Y, Classes::TShiftState Shift);
	void __fastcall NavigListMouseUp(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	HIDESBASE MESSAGE void __fastcall CMCtl3DChanged(Messages::TMessage &Message);
	virtual void __fastcall Loaded(void);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	virtual bool __fastcall CanSelect(TDate ADay);
	bool __fastcall InMonthOf(TDate Day1, TDate Day2);
	
public:
	__fastcall virtual TRBCalendar(Classes::TComponent* AOwner);
	__fastcall virtual ~TRBCalendar(void);
	void __fastcall GotoNextMonth(void);
	void __fastcall GotoPrevMonth(void);
	void __fastcall GotoToday(void);
	void __fastcall GotoDate(TDate Day);
	void __fastcall IndexesFromDate(int Month, int Year, int &I, int &J);
	void __fastcall SelectDates(TDate FromDate, TDate ToDate);
	void __fastcall AddSelection(TDate FromDate, TDate ToDate);
	void __fastcall RemoveSelection(TDate FromDate, TDate ToDate);
	void __fastcall SetSelection(TDate FromDate, TDate ToDate);
	void __fastcall ClearSelections(void);
	bool __fastcall GetDate(int X, int Y, TDate &ADate);
	void __fastcall UpdateChanges(void);
	bool __fastcall GetFirstSelected(TDate &Day);
	bool __fastcall GetNextSelected(TDate &Day);
	__property TDate SelectionFromDate = {read=FSelectionFromDate, write=SetSelectionFromDate};
	__property TDate SelectionToDate = {read=FSelectionToDate, write=SetSelectionToDate};
	__property int DaysSelected = {read=GetDaysSelected, nodefault};
	__property int MonthWidth = {read=FMonthWidth, nodefault};
	__property int MonthHeight = {read=FMonthHeight, nodefault};
	
__published:
	__property TRBCFirstWeekDay FirstWeekDay = {read=FFirstWeekDay, write=SetFirstWeekDay, default=0};
	__property Controls::TCursor Cursor = {read=FCursor, write=SetCursor, nodefault};
	__property TRBCSelectionKind SelectionKind = {read=FSelectionKind, write=SetSelectionKind, default=3
		};
	__property int MonthsInWidth = {read=FMonthsInWidth, write=SetMonthsInWidth, default=1};
	__property int MonthsInHeight = {read=FMonthsInHeight, write=SetMonthsInHeight, default=1};
	__property bool FixedSize = {read=FFixedSize, write=SetFixedSize, default=1};
	__property bool FlatLook = {read=FFlatLook, write=SetFlatLook, default=1};
	__property int DayWidth = {read=FDayWidth, write=SetDayWidth, default=16};
	__property int DayHeight = {read=FDayHeight, write=SetDayHeight, default=16};
	__property bool ShowLines = {read=FShowLines, write=SetShowLines, default=1};
	__property bool ShowNextMonth = {read=FShowNextMonth, write=SetShowNextMonth, default=0};
	__property bool ShowPrevMonth = {read=FShowPrevMonth, write=SetShowPrevMonth, default=0};
	__property Graphics::TColor PrevMonthColor = {read=FPrevMonthColor, write=SetPrevMonthColor, default=12632256
		};
	__property Graphics::TColor NextMonthColor = {read=FNextMonthColor, write=SetNextMonthColor, default=12632256
		};
	__property int BorderWidth = {read=FBorderWidth, write=SetBorderWidth, default=10};
	__property int CaptionHeight = {read=FCaptionHeight, write=SetCaptionHeight, default=16};
	__property int TitlesHeight = {read=FTitlesHeight, write=SetTitlesHeight, default=16};
	__property bool PrevMonthButton = {read=FPrevMonthButton, write=SetPrevMonthButton, default=1};
	__property bool NextMonthButton = {read=FNextMonthButton, write=SetNextMonthButton, default=1};
	__property bool ShowToday = {read=FShowToday, write=SetShowToday, default=1};
	__property Graphics::TColor TodayColor = {read=FTodayColor, write=SetTodayColor, default=255};
	__property Graphics::TColor TitlesColor = {read=FTitlesColor, write=SetTitlesColor, default=0};
	__property Classes::TAlignment DayAlignment = {read=FDayAlignment, write=SetDayAlignment, default=2
		};
	__property Graphics::TColor CaptionsColor = {read=FCaptionsColor, write=SetCaptionsColor, default=0
		};
	__property int Year = {read=FYear, write=SetYear, default=1998};
	__property int Month = {read=FMonth, write=SetMonth, default=9};
	__property int PopupListDays = {read=FPopupListDays, write=SetPopupListDays, default=3};
	__property bool SideWeekSelect = {read=FSideWeekSelect, write=SetSideWeekSelect, default=1};
	__property bool EnableCaptionPopup = {read=FEnableCaptionPopup, write=SetEnableCaptionPopup, default=1
		};
	__property Graphics::TColor SelectionColor = {read=FSelectionColor, write=SetSelectionColor, default=-2147483635
		};
	__property Graphics::TColor SelectionTextColor = {read=FSelectionTextColor, write=SetSelectionTextColor
		, default=-2147483634};
	__property Graphics::TColor DividersColor = {read=FDividersColor, write=SetDividersColor, default=12632256
		};
	__property bool ShowDividers = {read=FShowDividers, write=SetShowDividers, default=0};
	__property bool MultiSelect = {read=FMultiSelect, write=SetMultiSelect, nodefault};
	__property Forms::TBorderStyle BorderStyle = {read=FBorderStyle, write=SetBorderStyle, default=1};
	__property bool CanSelectAnother = {read=FCanSelectAnother, write=SetCanSelectAnother, default=1};
	__property int MaxSelections = {read=FMaxSelections, write=SetMaxSelections, default=0};
	__property bool CustomCellsDraw = {read=FCustomCellsDraw, write=SetCustomCellsDraw, nodefault};
	__property bool CustomCaptionsDraw = {read=FCustomCaptionsDraw, write=SetCustomCaptionsDraw, nodefault
		};
	__property bool CustomTitlesDraw = {read=FCustomTitlesDraw, write=SetCustomTitlesDraw, nodefault};
	__property Classes::TNotifyEvent OnSelectionChange = {read=FOnSelectionChange, write=FOnSelectionChange
		};
	__property TRBCMarkEvent OnMark = {read=FOnMark, write=SetOnMark};
	__property TRBCCanSelectEvent OnCanSelect = {read=FOnCanSelect, write=FOnCanSelect};
	__property TRBCCellDrawEvent OnCellDraw = {read=FOnCellDraw, write=FOnCellDraw};
	__property TRBCCaptionDrawEvent OnCaptionDraw = {read=FOnCaptionDraw, write=FOnCaptionDraw};
	__property TRBCTitleDrawEvent OnTitleDraw = {read=FOnTitleDraw, write=FOnTitleDraw};
	__property Align ;
	__property Constraints ;
	__property Anchors ;
	__property DragKind ;
	__property OnUnDock ;
	__property OnStartDock ;
	__property OnResize ;
	__property OnGetSiteInfo ;
	__property OnEndDock ;
	__property OnDockOver ;
	__property OnDockDrop ;
	__property OnConstrainedResize ;
	__property OnCanResize ;
	__property Color ;
	__property Font ;
	__property OnMouseUp ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property Ctl3D ;
	__property DragCursor ;
	__property DragMode ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRBCalendar(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
static const Shortint RBCDF_VALID = 0x1;
static const Shortint RBCDF_TODAY = 0x2;
static const Shortint RBCDF_MARKED = 0x4;
static const Shortint RBCDF_BEFORE_DAY = 0x8;
static const Shortint RBCDF_AFTER_DAY = 0x10;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Rbcalendar */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rbcalendar;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RBCalendar
